Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 74430)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -3736,196 +2903,124 @@
 
                 ir = (INODE_REF*)tp.item->data;
 
-                hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
-                if (!hl) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
+                parent = tp.item->key.offset;
                 
-                hl->parent = tp.item->key.offset;
-                hl->index = ir->index;
-                
-                hl->utf8.Length = hl->utf8.MaximumLength = ir->n;
-                
-                if (hl->utf8.Length > 0) {
-                    hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-                    RtlCopyMemory(hl->utf8.Buffer, ir->name, ir->n);
-                }
-                
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ir->name, ir->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                    ExFreePool(hl);
                     free_fcb(fcb);
                     return Status;
                 }
                 
-                hl->name.Length = hl->name.MaximumLength = stringlen;
+                name.Length = name.MaximumLength = stringlen;
                 
                 if (stringlen == 0)
-                    hl->name.Buffer = NULL;
+                    name.Buffer = NULL;
                 else {
-                    hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
+                    name.Buffer = ExAllocatePoolWithTag(PagedPool, name.MaximumLength, ALLOC_TAG);
                     
-                    if (!hl->name.Buffer) {
+                    if (!name.Buffer) {
                         ERR("out of memory\n");
-                        ExFreePool(hl);
                         free_fcb(fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
                     
-                    Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ir->name, ir->n);
+                    Status = RtlUTF8ToUnicodeN(name.Buffer, stringlen, &stringlen, ir->name, ir->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                        ExFreePool(hl->name.Buffer);
-                        ExFreePool(hl);
+                        ExFreePool(name.Buffer);
                         free_fcb(fcb);
                         return Status;
                     }
+                    
+                    hl_alloc = TRUE;
                 }
-                    
-                InsertTailList(&fcb->hardlinks, &hl->list_entry);
             } else if (tp.item->key.obj_type == TYPE_INODE_EXTREF) {
                 INODE_EXTREF* ier;
-                hardlink* hl;
                 ULONG stringlen;
 
                 ier = (INODE_EXTREF*)tp.item->data;
+
+                parent = ier->dir;
                 
-                hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
-                if (!hl) {
-                    ERR("out of memory\n");
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                hl->parent = ier->dir;
-                hl->index = ier->index;
-                
-                hl->utf8.Length = hl->utf8.MaximumLength = ier->n;
-                
-                if (hl->utf8.Length > 0) {
-                    hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-                    RtlCopyMemory(hl->utf8.Buffer, ier->name, ier->n);
-                }
-                
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ier->name, ier->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                    ExFreePool(hl);
                     free_fcb(fcb);
                     return Status;
                 }
                 
-                hl->name.Length = hl->name.MaximumLength = stringlen;
+                name.Length = name.MaximumLength = stringlen;
                 
                 if (stringlen == 0)
-                    hl->name.Buffer = NULL;
+                    name.Buffer = NULL;
                 else {
-                    hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
+                    name.Buffer = ExAllocatePoolWithTag(PagedPool, name.MaximumLength, ALLOC_TAG);
                     
-                    if (!hl->name.Buffer) {
+                    if (!name.Buffer) {
                         ERR("out of memory\n");
-                        ExFreePool(hl);
                         free_fcb(fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
-                    Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ier->name, ier->n);
+
+                    Status = RtlUTF8ToUnicodeN(name.Buffer, stringlen, &stringlen, ier->name, ier->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                        ExFreePool(hl->name.Buffer);
-                        ExFreePool(hl);
+                        ExFreePool(name.Buffer);
                         free_fcb(fcb);
                         return Status;
                     }
+
+                    hl_alloc = TRUE;
                 }
-                
-                InsertTailList(&fcb->hardlinks, &hl->list_entry);
+
             }
         }
+    } else {
+        hardlink* hl = CONTAINING_RECORD(fcb->hardlinks.Flink, hardlink, list_entry);
+        
+        name = hl->name;
+        parent = hl->parent;
     }
     
-    if (IsListEmpty(&fcb->hardlinks)) {
+    if (parent == 0) {
         ERR("subvol %llx, inode %llx has no hardlinks\n", subvol->id, inode);
         free_fcb(fcb);
-        return STATUS_INTERNAL_ERROR;
+        return STATUS_INVALID_PARAMETER;
     }
-    
-    hl = CONTAINING_RECORD(fcb->hardlinks.Flink, hardlink, list_entry);
-    
-    // FIXME - does this work with subvols?
-    
-    if (hl->parent == inode) // root of subvol
-        parfr = NULL;
-    else {
-        Status = open_fileref_by_inode(Vcb, subvol, hl->parent, &parfr, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("open_fileref_by_inode returned %08x\n", Status);
-            free_fcb(fcb);
-            return Status;
-        }
-    }
-    
-    fr = create_fileref();
-    if (!fr) {
-        ERR("out of memory\n");
+
+    Status = open_fileref_by_inode(Vcb, subvol, parent, &parfr, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("open_fileref_by_inode returned %08x\n", Status);
         free_fcb(fcb);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    fr->fcb = fcb;
-    fcb->fileref = fr;
-    
-    fr->index = hl->index;
-    
-    fr->utf8.Length = fr->utf8.MaximumLength = hl->utf8.Length;
-    if (fr->utf8.Length > 0) {
-        fr->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, fr->utf8.Length, ALLOC_TAG);
         
-        if (!fr->utf8.Buffer) {
-            ERR("out of memory\n");
-            free_fileref(fr);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
+        if (hl_alloc)
+            ExFreePool(name.Buffer);
         
-        RtlCopyMemory(fr->utf8.Buffer, hl->utf8.Buffer, hl->utf8.Length);
+        return Status;
     }
+
+    Status = open_fileref_child(Vcb, parfr, &name, TRUE, TRUE, FALSE, PagedPool, &fr, Irp);
     
-    fr->filepart.MaximumLength = fr->filepart.Length = hl->name.Length;
-    
-    if (fr->filepart.Length > 0) {
-        fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-        if (!fr->filepart.Buffer) {
-            ERR("out of memory\n");
-            free_fileref(fr);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
+    if (!NT_SUCCESS(Status)) {
+        ERR("open_fileref_child returned %08x\n", Status);
         
-        RtlCopyMemory(fr->filepart.Buffer, hl->name.Buffer, hl->name.Length);
-    }
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fr);
+        if (hl_alloc)
+            ExFreePool(name.Buffer);
+        
+        free_fcb(fcb);
+        free_fileref(Vcb, parfr);
+        
         return Status;
     }
     
-    fr->parent = parfr;
-    
-    Status = add_dir_child(parfr->fcb, fr->fcb->inode == SUBVOL_ROOT_INODE ? fr->fcb->subvol->id : fr->fcb->inode, fr->fcb->inode == SUBVOL_ROOT_INODE,
-                           fr->index, &fr->utf8, &fr->filepart, &fr->filepart_uc, fr->fcb->type, &dc);
-    if (!NT_SUCCESS(Status))
-        WARN("add_dir_child returned %08x\n", Status);
-    
-    fr->dc = dc;
-    dc->fileref = fr;
-    
-    insert_fileref_child(parfr, fr, TRUE);
+    *pfr = fr;
 
-    *pfr = fr;
+    if (hl_alloc)
+        ExFreePool(name.Buffer);
+
+    free_fcb(fcb);
+    free_fileref(Vcb, parfr);
     
     return STATUS_SUCCESS;
 }
@@ -3960,7 +3055,7 @@
         if (fcb == fcb->Vcb->root_fileref->fcb)
             namelen = sizeof(WCHAR);
         else
-            namelen = fileref->filepart.Length;
+            namelen = fileref->dc->name.Length;
                     
         bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) - sizeof(WCHAR) + namelen;
         
@@ -3977,8 +3072,8 @@
                 feli->FileNameLength = 1;
                 feli->FileName[0] = '.';
             } else {
-                feli->FileNameLength = fileref->filepart.Length / sizeof(WCHAR);
-                RtlCopyMemory(feli->FileName, fileref->filepart.Buffer, fileref->filepart.Length);
+                feli->FileNameLength = fileref->dc->name.Length / sizeof(WCHAR);
+                RtlCopyMemory(feli->FileName, fileref->dc->name.Buffer, fileref->dc->name.Length);
             }
             
             fli->EntriesReturned++;
@@ -3989,7 +3084,7 @@
         ExAcquireResourceExclusiveLite(&fcb->Vcb->fcb_lock, TRUE);
     
         if (IsListEmpty(&fcb->hardlinks)) {
-            bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) + fileref->filepart.Length - sizeof(WCHAR);
+            bytes_needed += sizeof(FILE_LINK_ENTRY_INFORMATION) + fileref->dc->name.Length - sizeof(WCHAR);
             
             if (bytes_needed > *length)
                 overflow = TRUE;
@@ -3999,8 +3094,8 @@
 
                 feli->NextEntryOffset = 0;
                 feli->ParentFileId = fileref->parent->fcb->inode;
-                feli->FileNameLength = fileref->filepart.Length / sizeof(WCHAR);
-                RtlCopyMemory(feli->FileName, fileref->filepart.Buffer, fileref->filepart.Length);
+                feli->FileNameLength = fileref->dc->name.Length / sizeof(WCHAR);
+                RtlCopyMemory(feli->FileName, fileref->dc->name.Buffer, fileref->dc->name.Length);
                 
                 fli->EntriesReturned++;
                 
@@ -4027,12 +3122,12 @@
                     while (le2 != &parfr->children) {
                         file_ref* fr2 = CONTAINING_RECORD(le2, file_ref, list_entry);
                         
-                        if (fr2->index == hl->index) {
+                        if (fr2->dc->index == hl->index) {
                             found = TRUE;
                             deleted = fr2->deleted;
                             
                             if (!deleted)
-                                fn = &fr2->filepart;
+                                fn = &fr2->dc->name;
                             
                             break;
                         }
@@ -4072,7 +3167,7 @@
                         }
                     }
                     
-                    free_fileref(parfr);
+                    free_fileref(fcb->Vcb, parfr);
                 }
                 
                 le = le->Flink;
@@ -4205,7 +3300,9 @@
                 goto exit;
             }
             
+            ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
             Status = fill_in_file_attribute_information(ati, fcb, fileref, Irp, &length);
+            ExReleaseResourceLite(&Vcb->tree_lock);
             
             break;
         }
@@ -4333,7 +3430,7 @@
             
             TRACE("FileStreamInformation\n");
             
-            Status = fill_in_file_stream_information(fsi, fileref, Irp, &length);
+            Status = fill_in_file_stream_information(fsi, fileref, &length);
 
             break;
         }
@@ -4345,7 +3442,9 @@
             
             TRACE("FileHardLinkInformation\n");
             
+            ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
             Status = fill_in_hard_link_information(fli, fileref, Irp, &length);
+            ExReleaseResourceLite(&Vcb->tree_lock);
             
             break;
         }
@@ -4432,9 +3531,12 @@
     
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     Irp->IoStatus.Information = 0;
@@ -4443,8 +3545,6 @@
     
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
     
-    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
     fcb = IrpSp->FileObject->FsContext;
     TRACE("fcb = %p\n", fcb);
     TRACE("fcb->subvol = %p\n", fcb->subvol);
@@ -4451,6 +3551,7 @@
     
     Status = query_info(fcb->Vcb, IrpSp->FileObject, Irp);
     
+end:
     TRACE("returning %08x\n", Status);
     
     Irp->IoStatus.Status = Status;
@@ -4457,9 +3558,6 @@
     
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
     
-    ExReleaseResourceLite(&Vcb->tree_lock);
-    
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -4485,9 +3583,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_ea(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     ffei = map_user_buffer(Irp);
@@ -4679,7 +3780,6 @@
 
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
 
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -4718,9 +3818,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_ea(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     if (Vcb->readonly) {
@@ -4974,7 +4077,6 @@
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
